# This file is for testing the openstack api access

import openstack

from implementation.network.OpenstackFloatingIPManager import OpenstackFloatingIPManager
from implementation.network.OpenstackNetworkManager import OpenstackNetworkManager
from implementation.network.OpenstackPortManager import OpenstackPortManager
from implementation.network.OpenstackRouterManager import OpenstackRouterManager
from implementation.network.OpenstackSubnetManager import OpenstackSubnetManager

os = openstack.connect(cloud='openstack')

router_manager = OpenstackRouterManager(os)
network_manager = OpenstackNetworkManager(os)
subnet_manager = OpenstackSubnetManager(os)
port_manager = OpenstackPortManager(os)
floating_ip_manager = OpenstackFloatingIPManager(os)

#router = router_manager.create()
router = router_manager.get('3ee87bcd-b1b5-4e14-86a1-ce691bd3e5a2')

print('Router:')
print('\t%s' % router)

#network = network_manager.create()
public_network = network_manager.get('3b349c93-8b2c-4abd-b8ce-22b7db4cca98')
inner_network = network_manager.get('ac15d5e2-f32e-4ea3-9fa5-345d3e147aa5')

print('Network:')
print('\tPublic: %s' % public_network)
print('\tInner: %s' % inner_network)

#subnet = subnet_manager.create(network.id, 4, '10.34.0.0/16')
public_subnet = subnet_manager.get('8a7e05f8-6358-48f7-9104-990d350425a0')
inner_subnet = subnet_manager.get('b7650962-4323-475c-9ee6-08d64e2c8577')

print('Subnet:')
print('\tPublic: %s' % public_subnet)
print('\tInner: %s' % inner_subnet)

vm_port = port_manager.get('bd1f0753-613d-4ecf-8605-eacc3ca63373') # inner

print('Port:')
print('\tVM: %s' % vm_port)

#floating_ip = floating_ip_manager.create(public_network.id)
floating_ip = floating_ip_manager.get('df353eb0-9f0b-4bee-9492-148e29873450')

print('Floating IP:')
print('\tFloating IP: %s' % floating_ip)


#print(router_manager.add_interface(router.id, subnet.id))
#print(router_manager.add_gateway(router.id, public_network.id)) # TODO: fix it!

# print(floating_ip_manager.update(floating_ip.id, {
#    'port_id': vm_port.id
# }))